; Now draw the maze, etc ( J.Garside )

; Get some storage

Get_BigMaze:	mov bx,BM_Size		; Get this much RAM

		mov ah,Allocate_Mem	; Get some memory
		int dos			; Get it

		mov cs:BM_Base,ax	; Store start paragraph

		ret			; Done (CF = Error)

; Map is in "DS:Small_maze" in rows, top to bottom.
; Each byte contains the room map :-  0 0 0 0 R L D U

init_small_maze:push	cx
		push	di
		push	es

		; This code uses the data seg for small-maze.

		mov ax,Data		; Initialise data segment

		mov ds,ax		; DS
		mov es,ax		; ES

		mov	al,no_go_char
		mov	cx,(breadth+2)	; Counter
		mov	di,o Small_maze	; Pointer
	rep	stosb

		mov	al,000h
		mov	cx,(breadth+2)*height	; Counter
	rep	stosb

		mov	al,no_go_char
		mov	cx,(breadth+2)		; Counter
	rep	stosb

		mov	cx,height+1			; Counter
		mov	di,o Small_maze+breadth+1	; Pointer

		mov	ax,no_go_char*00101h
init_sm1:	mov	[di],ax
		add	di,breadth+2
		loop	init_sm1

		call	init_room		;
		call	init_pillars		;

		pop	es			;
		pop	di			;
		pop	cx			;
		ret				;


init_room:	mov	di,o Small_maze+2*(breadth+2)+2
		mov	b  [di],room_char	;
		mov	b 1[di],room_char	;
		mov	b 2[di],room_char	;

;		mov	b (breadth+3)[di],room_char
;		mov	b (breadth+4)[di],room_char
		ret


init_pillars:	push	ax			;
		push	cx			;
		push	dx			;
		push	di			;

		mov	cx,No_pillars		;

init_pill1:	call	Rand_32			;
		mov	dx,(breadth+2)*height	;
		mul	dx			;

		mov	di,o Small_maze+(breadth+2)
		add	di,dx			; May hit outer edges (so what?)

	mov	al,000h
	cmp	(-(breadth+3))[di],al
	jne	init_pill1
	cmp	(-(breadth+1))[di],al
	jne	init_pill1
	cmp	(breadth+1)[di],al
	jne	init_pill1
	cmp	(breadth+3)[di],al
	jne	init_pill1
	cmp	[di],al
	jne	init_pill1

		mov	b [di],pillar_char

		loop	init_pill1		;

		pop	di			;
		pop	dx			;
		pop	cx			;
		pop	ax			;
		ret				;


build_small_maze:push	ax			;
		push	bx			;
		push	cx			;
		push	dx			;
		push	si			;
		push	di			;
		push	bp			;
		push	es			;

		mov	di,o Small_maze	; Point at map

		mov	bp,00101h		; Initial coordinates
		mov	dx,bp			;

		xor	si,si			; Length of run counter
		mov	b cs:maze_done_flag,000h	;

		jmp	wander			; Don't link first cell

rerun:		mov	di,o Small_maze	; Restart across maze
		mov	dx,00101h	; Initial coordinates
		mov	b cs:maze_done_flag,000h	;

run:		xor	si,si			; Length of run counter

		mov	bp,dx			; Init. start position save

		call	bsm_test_free		; See if this cell unmolested
		jnc	link_back		;  yes
		jmp	next_cell		;  no

link_back:	inc	dh			; Try down first

		call	bsm_test_free		;
		jnc	link_back1		; Nothing in cell
		jz	link_back1		; Outside maze

		mov	al,001h			;
		call	bsm_put			;

		dec	dh			;
		mov	al,002h			;
		call	bsm_put			;
		jmp	wander			;

link_back1:	dec	dh			; Then right
		inc	dl			;
		call	bsm_test_free		;
		jnc	link_back2		; Nothing in cell
		jz	link_back2		; Outside maze

		mov	al,004h			;
		call	bsm_put			;

		dec	dl			;
		mov	al,008h			;
		call	bsm_put			;
		jmp	wander			;

link_back2:	dec	dl			; Up next
		dec	dh			;
		call	bsm_test_free		;
		jnc	link_back3		; Nothing in cell
		jz	link_back3		; Outside maze

		mov	al,002h			;
		call	bsm_put			;

		inc	dh			;
		mov	al,001h			;
		call	bsm_put			;
		jmp	wander			;

link_back3:	inc	dh			; Finally left
		dec	dl			;

		call	bsm_test_free		;
		jnc	link_back_fail		; Nothing in cell
		jz	link_back_fail		; Outside maze

		mov	al,008h			;
		call	bsm_put			;

		inc	dl			;
		mov	al,004h			;
		call	bsm_put			;

wander:		mov	cx,No_looks		; Number of attempts to move

		inc	si			; Length of run

wander1:	mov	es,dx			; Copy coordinates
		call	Rand_32			; Choose direction
		mov	dx,es			; Recover position

		mov	ah,001h			; Direction mask
		and	al,003h			; Get 2-bit number
		jz	going_up		;

		shl	ah,1			; Shift mask
		dec	al			;  and count off numbers
		jz	going_down		;

		shl	ah,1			;
		dec	al			;
		jz	going_left		;

		shl	ah,1			;

		inc	dl			; Check if next cell unused
		call	bsm_test_free		;
		jc	not_this_way		; Already used
		dec	dl			;

		mov	al,ah			;
		call	bsm_put			;

		inc	dl			;
		mov	al,004h			;
		jmp	new_cell		;

link_back_fail:	or	b cs:maze_done_flag,0FFh	;
		jmp	next_cell		;

		; This bit of code is here to assist 8-bit branches

not_this_way:	mov	dx,es			; Restore original coordinates

		loop	wander1			; Bridge to loop 
						; (NB. BP holds old pos)

next_cell:	mov	dx,bp			; Step start position in X
		inc	dl			;
		cmp	dl,breadth+1		;
		jne	run_bridge		;

		mov	dl,001h			; New row
		inc	dh			;
		cmp	dh,height+1		;
		jne	run_bridge		;

		test	b cs:maze_done_flag,0FFh	;
		jnz	rerun_bridge		;

		pop	es			;
		pop	bp			;
		pop	di			;
		pop	si			;
		pop	dx			;
		pop	cx			;
		pop	bx			;
		pop	ax			;
		ret				;

run_bridge:	jmp	run			;
rerun_bridge:	jmp	rerun			;


going_left:	dec	dl			; Check if next cell unused
		call	bsm_test_free		;
		jc	not_this_way		; Already used
		inc	dl			;

		mov	al,ah			;
		call	bsm_put			;

		dec	dl			;
		mov	al,008h			;
		jmp	new_cell		;


going_up:	dec	dh			; Check if next cell unused
		call	bsm_test_free		;
		jc	not_this_way		; Already used
		inc	dh			;

		mov	al,ah			;
		call	bsm_put			;

		dec	dh			;
		mov	al,002h			;
		jmp	new_cell		;


going_down:	inc	dh			; Check if next cell unused
		call	bsm_test_free		;
		jc	not_this_way		; Already used
		dec	dh			;

		mov	al,ah			;
		call	bsm_put			;

		inc	dh			;
		mov	al,001h			;


new_cell:	call	bsm_put			;

		jmp	wander			;


bsm_test_free:	push	bx			; C=0 if unused cell
		push	ax			;  else Z=1 if out of maze
						; NB. Should be within 1
						; place of edge if outside maze

		mov	al,dh			; Y coord. * line length
		mov	ah,breadth+2		;
		mul	ah			;

		mov	bh,000h			; X coord. into 16 bits
		mov	bl,dl			;

		add	bx,ax			; Calc. offset into map

		mov	al,b [bx+di]	; Test if used
		cmp	al,000h			;
		jnz	bsb_t_f_fail		;

		pop	ax			; C=0 if okay
		pop	bx			;
		ret				;

bsb_t_f_fail:	cmp	al,no_go_char		; Out of bounds character
		je	bsb_t_f_f1		;
		cmp	al,room_char		; Room character
		je	bsb_t_f_f1		;
		cmp	al,pillar_char		;
bsb_t_f_f1:	stc				; C=1 if not free or out of bounds
		pop	ax			; Z=1 if out of maze (?!)
		pop	bx			;
		ret				;


bsm_put:	push	bx			;
		push	ax			;

		mov	al,dh			; Y coord. * line length
		mov	ah,breadth+2		;
		mul	ah			;

		mov	bh,000h			; X coord. into 16 bits
		mov	bl,dl			;

		add	bx,ax			; Calc. offset into map
		pop	ax			; Recover character

		or	[bx+di],al		; Add entry to maze

		pop	bx			;
		ret				;


draw_small_maze:push	ax			; Sketch up small maze
		push	bx			;
		push	cx			;
		push	dx			;
		push	si			;
		push	di			;
		push	bp			;
		push	es			;

		mov	si,o Small_maze	; Point at map

		mov	bx,height+2		;
		mov	dh,8			; Start position in Y

dsm1:		mov	cx,breadth+2		;
		mov	dl,34			; Start position in X


dsm2:		lodsb				; Fetch character
		inc	al			; (move to correct character)
		and	al,00Fh			;
		call	OutIt			;  and display

		inc	dl			; Loop in X
		loop	dsm2			;

dsm3:		inc	dh			; Loop in Y
		dec	bx			;
		jnz	dsm1			;

		pop	es			;
		pop	bp			;
		pop	di			;
		pop	si			;
		pop	dx			;
		pop	cx			;
		pop	bx			;
		pop	ax			;
		ret				;


expand:		push	ax			; Expand small maze
		push	bx			;  into big maze
		push	cx			;
		push	si			;
		push	di			;
		push	bp			;
		push	es			;

		call	zero_bm			;

		mov	al,0FFh			; Sketch in the outer border
		mov	bx,cs:BM_Base		;
		mov	es,bx			;
		xor	di,di			;
		mov	cx,BM_Max_X+2		;
	rep	stosb				;

		mov	cx,BM_Max_Y		;
		xor	di,di			;
exp_border:	add	bx,BM_Y_Stride		;
		mov	es,bx			;
		mov	es:[di],al		;
		mov	es:(BM_Max_X+1)[di],al	;
		loop	exp_border		;

		add	bx,BM_Y_Stride		;
		mov	es,bx			;
		mov	cx,BM_Max_X+2		;
	rep	stosb				;

		mov	cx,cs:BM_Base		; Do top wall
		add	cx,BM_Y_Stride		; One cell from top
		mov	es,cx			;
		mov	bx,breadth 		;
		mov	si,o Small_maze+breadth+3
		mov	di,00001h		;

exp_TW:		mov	cx,7			;
		mov	ah,[si]			;
		inc	si			;
		mov	al,093h			; Wall character
		test	ah,no_go_char		;
		jz	exp_TW1			;
		mov	al,0FFh			; Moat
exp_TW1:rep	stosb				;
		dec	bx			;
		jnz	exp_TW			;


		mov	bp,cs:BM_Base		;
		mov	si,o Small_maze+breadth+3

		mov	bh,height		;

exp_inner:	mov	di,(BM_Y_Stride*16)+1	; Point to first row just below
		mov	es,bp			;  walls

		mov	cx,7			;
		mov	ah,[si]			;
		mov	al,09Ch			; Wall character
		test	ah,no_go_char		;
		jz	exp_LW			;
		mov	al,0FFh			; Moat
exp_LW:		add	di,BM_Y_Stride*16	;
		mov	es:[di],al		;
		loop	exp_LW			;

		inc	di			;
		mov	bl,breadth		;

exp_inner1:	mov	al,[si]			; Get small maze entry
		test	al,002h			; Test for exit at bottom
		jnz	exp_inner2		; Exit present

		mov	cx,7			; Put in bottom wall
		mov	al,093h
	rep	stosb

		jmp	exp_inner3

exp_inner2:	add	di,00007h		; Vary exits here

exp_inner3:	mov	al,[si]			; Read small maze again
		test	al,008h			; Exit to right ?
		jnz	exp_inner5		;  yes

		mov	cx,6
		mov	al,09Ch
		sub	di,BM_Y_Stride*16*6+1	; (+1 'cos of auto inc. before)
exp_inner4:	mov	es:[di],al
		add	di,BM_Y_Stride*16
		loop	exp_inner4

		inc	di			; Allow for auto-inc.
		jmp	exp_inner6		;

exp_inner5:	nop				; Vary exits here

exp_inner6:	lodsb				; Check and increment pointer

		test	al,0A0h			; no-go or pillar character ?
		jz	exp_inner7		;  no

		call	exp_pillar		; Fit up suitable pillar stuff here

exp_inner7:	cmp	al,room_char		;
		jne	exp_inner8		;

		call	exp_room		; All except door

exp_inner8:	dec	bl			;
		jnz	exp_inner1		;

		add	si,2			;
		add	bp,BM_Y_Stride*7	;
		dec	bh			;
		jnz	exp_inner		;

		mov	dh,height+1		; Now do all the junctions
		mov	bp,cs:BM_Base		;

corners:	mov	dl,breadth+1		;
		mov	es,bp			;
		mov	di,(BM_Y_Stride*16) + 1	;

corners1:	call	wall_junction		;

		add	di,7			; Step to next corner

		dec	dl			;
		jnz	corners1		;

		add	bp,(BM_Y_Stride*7)	; Step down to next corner row

		dec	dh			;
		jnz	corners			;

		; Now place messages in the maze

		mov bx,o sTitle			; Point at data

Exp_Mess_Lp:	mov di,cs:[bx]			; Get X
		add bx,2			;

		cmp di,0			; Done ?
		jz Exp_Exit			; Yes, skip

		mov ax,cs:[bx]			; Y
		add bx,2			;

		call Calc_pBM			; Return es:di as ptr

EM_Lp2:		mov al,cs:[bx]			; Get char
		inc bx				;

		cmp al,0			; End ?
		jz Exp_Mess_Lp			; Yes, try next

		mov es:[di],al			; Store it
		inc di				;

		jmp EM_Lp2			; Loop

Exp_Exit:	pop es				; Restore
		pop bp				;
		pop di				;
		pop si				;
		pop cx				;
		pop bx				;
		pop ax				;
		ret				;

; Given ax = Y, return es

Calc_pBM:	push dx				; Save
		push ax				;

		mov dx,BM_Y_Stride		; X size in paras

		mul dx				; Y index into BM in paras

		add ax,cs:BM_Base		; Start of BM
		mov es,ax			; As data seg.

		pop ax				; Restore
		pop dx				;
		ret				;

; Fill a pillar

exp_pillar:	push	ax			; Fill pillar or other
		push	cx			;  no-go area
		push	dx			;
		push	di			;

		mov	ah,al			;
		mov	al,0FEh			; Pillar

		sub	di,6*(BM_Y_Stride*16)+7	;

		mov	dx,6			; Fill body of cell
exp_pillar1:	mov	cx,6			;
	rep	stosb				;

		add	di,(BM_Y_Stride*16)-6	;
		dec	dx			;
		jnz	exp_pillar1		;

		cmp	b (Breadth+1)[si],ah
		jne	exp_pillar2		;

		mov	cx,6			; Cover bottom wall
	rep	stosb				;

exp_pillar2:	pop	di			;
		push	di			;

		cmp	b [si],ah		; Right wall
		jne	exp_pillar4		;

		sub	di,6*(BM_Y_Stride*16)+1	;
		mov	cx,6			;

exp_pillar3:	mov	es:[di],al		; Cover right wall
		add	di,(BM_Y_Stride*16)	;
		loop	exp_pillar3		;		

exp_pillar4:	pop	di			;
		pop	dx			;
		pop	cx			;
		pop	ax			;
		ret				;


exp_room:	push	ax			; Allow for rooms
		push	cx			; (except doors)
		push	dx			;
		push	di			;

		mov	al,000h			; Fill the room with this

		cmp	b (Breadth+1)[si],room_char
		jne	exp_room1		;

		mov	cx,6			; Cover bottom wall
		sub	di,7			;
	rep	stosb				;

exp_room1:	pop	di			;
		push	di			;

		cmp	b [si],room_char	; Right wall
		jne	exp_room3		;

		sub	di,6*(BM_Y_Stride*16)+1	;
		mov	cx,6			;

exp_room2:	mov	es:[di],al		; Cover right wall
		add	di,(BM_Y_Stride*16)	;
		loop	exp_room2		;		

exp_room3:	pop	di			;
		pop	dx			;
		pop	cx			;
		pop	ax			;
		ret				;


zero_bm:	push	ax			; Sets Big Maze to all zero
		push	bx			;  except for border
		push	cx			;
		push	di			;
		push	es			;

		mov	dx,cs:BM_Base		;

		mov	bx,BM_Max_Y+2		;

		mov	al,000h			;

zbm1:		mov	es,dx			;

		mov	cx,BM_Max_X+2		;

		mov	di,00000h		;

	rep	stosb				;

		add dx,BM_Y_Stride		; Step Y

		dec	bx			;
		jnz	zbm1			;

		pop	es			;
		pop	di			;
		pop	cx			;
		pop	bx			;
		pop	ax			;
		ret				;


wall_junction:	push	ax			;
		mov	al,009h			; Base for set of wall char.s

		sub	di,16*BM_Y_Stride	; Look up
		call	is_wall			;
		rcl	al,1			;

		add	di,32*BM_Y_Stride	; Look down
		call	is_wall			;
		rcl	al,1			;

		sub	di,16*BM_Y_Stride+1	; Look left
		call	is_wall			;
		rcl	al,1			;

		inc	di			; Look right
		inc	di			;
		call	is_wall			;
		rcl	al,1			;
		dec	di			;

		cmp	al,090h			; Isolated wall ?
		jne	wall_junc1		;  no ...

		mov	al,es:1[di]		; Copy in adjacent character

wall_junc1:	mov	es:[di],al		;
		pop	ax			;
		ret				;

is_wall:	push	ax			; Return CF=1 if wall at ES:DI
		mov	al,es:[di]		;
		and	al,0F0h			;
		cmp	al,090h			;
		clc				; In case there isn't ...
		jne	no_wall			;
		stc				; If there is ...
no_wall:	pop	ax			;
		ret				;


; Giz a place which is not used

Safe_Rand_Pos:	call Rand_Pos		; Get a safe place
		cmp b es:[di],000h	;
		jne Safe_Rand_Pos	;

		ret			; Done

; Giz us a place in the maze

Rand_Pos:	push ax			; Pick a random point in the maze
		push dx			;

		call Rand_32		;

		mov dx,(height*7)-1	; Miss out top and bottom walls
		mul dx			;

		mov ax,BM_Y_Stride	;
		mul dx			;

		add ax,cs:BM_Base	;

		add ax,BM_Y_Stride*2	; Justify Y

		mov es,ax		; Start of line, 2 lines above

		call Rand_32		;
		mov dx,breadth*7-1	; Miss out left and right walls
		mul dx			;
		mov di,dx		;

		add di,2		; Justify X

		pop dx			;
		pop ax			;
		ret 			;

Print_str_code:	push	ax		; String at CS:DI, terminated by ttr
		push	dx		; (DL,DH) is position of first character
		push	di		;

pnt_str_cd1:	mov	al,cs:[di]	; Fetch character
		inc	di		;

		cmp	al,ttr		;
		je	pnt_str_cd2	;

		call	OutIt		;

		inc	dl		; Step position

		jmp	pnt_str_cd1

pnt_str_cd2:	pop	di		;
		pop	dx		;
		pop	ax		;
		ret			;

; Data starts here

BM_Base		dw ?			; Start paragraph of big maze
maze_done_flag	db ?

