; Monster driving code ( S.Brattel )

; Grab some storage

Get_Monsters:	mov bx,Monster_Size	; Get this much RAM

		mov ah,Allocate_Mem	; Get some memory
		int dos			; Get it

		mov cs:Monster_Base,ax	; Store start paragraph

		ret			; Done (CF = Error)

; Setup the monsters

init_things:	push ax			; Save them, don't know why . . 
		push cx			;
		push dx			;
		push si			;
		push di			;
		push ds			;
		push es			;

		mov si,cs:Monster_Base	;
		mov ds,si		;
		xor si,si		;

		; Clear the monster list

		mov di,si		; Clear its workspace

		push es			; Save segment
		push cx			;      length

		push ds			; Setup es
		pop es			;

		mov al,0		; Clear to 00
		mov cx,lMon*(nMons+1)	; Length
	rep	stosb

		; The first monster in the list is the man

		mov w mSouls[si],1	; One soul so far

		mov b mUnderChar[si]," "; We start on some spaces

		; Speed

		mov b mSpeed[si],Man_SP	; Setup speed
		mov b mDelay[si],1	;

		; Store position

		mov b mDirection[si],2	; Initial direction

		mov ax,13		; Y
		call Calc_pBM		; es = seg

		mov ax,es		; Seg

		mov mSeg[si],ax		; Store seg
		mov w mOff[si],18	; X

		; Code

		mov w mpMove[si],o MM_Man; Set the algorithm

		; Some magic

		mov b mMagic[si],128	; Start out half full

		; Set the man's flags     

		mov b mFlags[si],06h	; Assert Man & Sword

		pop cx			; Restore
		pop es			;

		mov si,lMon		; Step past the man's data

		mov cx,nMons		;

init_things1:	call Rand_32		; Random speed

		and ax,0071Fh		; Dirn and Speed

		add al,17		; Base speed
		mov mSpeed[si],al	; Store it

		mov b mDelay[si],1	; Initial count

		mov mDirection[si],ah	; Initial direction

		mov b mMagic[si],4	; Start out nearly empty

		mov w mSouls[si],1	; One soul so far

		mov b mType[si],2	; "Type" = 2 (men = 0/1)

		; Now get a monster from the table

		call Rand_32		; Randomly
		and ax,0007h		; 0 .. 7

		mov di,ax		;
		add ax,ax		;
		add di,ax		; * 3

		add di,o Mon_T_Table	; Point at entry

		mov ax,cs:[di]		; Get pMove
		mov w mpMove[si],ax	; Set the algorithm

		mov al,cs:2[di]		; Get char
		mov mChar[si],al	; Store monster char

		; Giz posn.

		call Safe_Rand_Pos	; Get a safe place

		mov b es:[di],al	; Store the monster

		mov mOff[si],di 	; Save offset
		mov di,es               ; Save segment
		mov mSeg[si],di         ;

		; Skip to next monster

		add si,lMon		; Step to next

		loop init_things1	; Loop

		; Setup first thing

		mov si,lMon

		mov ax,5		; Y
		call Calc_pBM		; es = seg

		mov ax,es		; Seg

		mov mSeg[si],ax		; Store seg
		mov w mOff[si],18	; X

		mov b mSpeed[si],200

		pop es			; Restore
		pop ds			;
		pop di			;
		pop si			;
		pop dx			;
		pop cx			;
		pop ax			;
		ret			;

; Monster defn.

Mon_T_Table	dw MM_LHW		;
		db cMonsters+0		;

		dw MM_RHW		;
		db cMonsters+1		;

		dw MM_LHW		;
		db cMonsters+2		;

		dw MM_RHW		;
		db cMonsters+3		;

		dw MM_LHW		;
		db cMonsters+4		;

		dw MM_RHW		;
		db cMonsters+5		;

		dw MM_LHW		;
		db cMonsters+7		;

		dw MM_RHW		;
		db cMonsters+7		;

; Move the monsters, including the man

move_monsters:	push cx			;
		push si			;
		push ds			;

		mov si,cs:Monster_Base	;
		mov ds,si		;
		xor si,si		;

		; Drive the status here (the man)

		call Drive_Status	; Show the score, etc

		; Now move him

		mov cx,nMons+1		; This many (including the man)

MM_Lp:		dec b mDelay[si]	; Time to move yet ?
		jnz MM_Next		; No, skip

		; Is it alive ?

		test b mFlags[si],80h	; Bit 7 = Dead
		jnz MM_Dead		; Dead, could be steaming

		; Perform some healing

		test b mWounds[si],0FFh	; Any wounds ?
		jz MM_NotHeal1		; No, skip

		; Accumulate magic-related healing

		mov ax,mWounds_Frac[si]	; Accumulate health
		add al,mMagic[si]	;
		adc ah,0		;

		cmp ax,Medicine_C	; Healed count ?
		jb MM_NotHeal		; Yes, skip

		sub ax,Medicine_C	; Allow for this heal

		; Heal the damn thing

		dec b mWounds[si]	; Heal slightly

MM_NotHeal:	mov mWounds_Frac[si],ax	; Store cnt

		; Does it have a sword ?

MM_NotHeal1:	test b mFlags[si],02h	; Check sword
		jz MM_NotSword		; No, skip

		; Remove the damn' thing

		mov di,mSwordSeg[si]	; Giz seg				

		cmp di,0		; Valid ?
		jz MM_NotSword		; No, skip

		mov es,di		; Set it

		mov di,mSwordOff[si]	; Off

		; Iff this is a sword, remove it

		mov al,es:[di]		; Giz the char
		and al,0FCh		; E4 .. E7

		cmp al,cSwords		; Is it a sword ?
		jne MM_NotSword		; No, skip

		; It's a sword, clear it

		mov al,0		; Blank
		mov b es:[di],al	; Clear this cell

		call ShowAddr		; Clear it on the screen

		; Yes, move it

MM_NotSword:	call mpMove[si]		; Point at the move routine

		; Now we replace the bloody sword iff there is one

		test b mFlags[si],02h	; Check sword
		jz MM_Next		; No, skip

		; Find the correct cell

		call Calc_Local		; Return di/bx as the local cells

		; Is it free ?

		test b es:[di],0DFh	; 00 or 20 (space)
		jne MM_NoSw_1		;

		; Yes, draw sword

		mov bl,mDirection[si]	; Giz dirn
		and bx,0007		; 16-bit

		add bx,o MM_SwordTab	; Add base

		mov al,cs:[bx]		; Get char
		mov b es:[di],al	; Write sword

		call ShowAddr		; Show on screen

		; Save posn.

		mov mSwordOff[si],di	; Save offset

		mov ax,es		; Get seg

		mov mSwordSeg[si],ax	; Save it

		; Next

MM_Next:	add si,lMon		; Skip Monster

		loop MM_Lp		; Loop

		pop ds			; Restore
		pop si			;
		pop cx			;
		ret			;

		; Now cope with dead monsters

MM_Dead:	test b mFlags[si],40h	; Steaming ?
		jz MM_Next		; No, ignore it

		; Step the character

		mov al,mChar[si]	; Cycle the char

		inc al			;
		and al,03h		;
		or al,cDead_Magic	;

		mov mChar[si],al	; Store it

		; Store it in the maze

		mov di,mSeg[si]		; Seg
		mov es,di		;
		mov di,mOff[si]		; Offset

		mov es:[di],al		; Store the monster
		call ShowAddr		;

		; Step steam cnt

		mov al,mSteamCnt[si]	; Get counter
		inc al			; Step
		mov mSteamCnt[si],al	; Store it

		js MM_StopSteam		; Kill the steaming

		; Setup speed

		shr al,1		; / 2

		add al,mSpeed[si]	; Base
		add mDelay[si],al	; Save cnt

		jmp s MM_Next		; Loop

; Stop the steaming

MM_StopSteam:	mov b mFlags[si],080h	; Clear steam flag etc.

		; Replace char

		mov al,cDead_ExMagic	; New char

		mov es:[di],al		; Store
		call ShowAddr		;

		jmp s MM_Next		; Loop

		; What have we shoved the sword into ?

MM_NoSw_1:	mov w mSwordSeg[si],0	; Flag sword not shown

		mov al,es:[di]		; Giz the char

		and al,0F8h		; Lose type bits

		cmp al,cMan		; Is it a man ?
		je MM_NS_2		; Yes, skip

		cmp al,cMonsters	; Is it a thing ?
		jne MM_Next		; No, skip

		; We are poking a thing, hit it

MM_NS_2:	mov al,Sword_Dam	; Do this much damage
		mov ah,0		; with a sword

		mov bx,si		; Point at sword's owner

		call Hit_Thing		; Damage it

		jmp s MM_Next		; Loop

; Some code for keep and drop, this was written for the man but will work for
; a THING if you want pick/drop to behave exactly the same way as they do for
; the man. NOTE - I reserve the right to change the way these behave !(SMB)

; Also look at Thing_KeepCell, which is intended for things, and doesn't allow
; things to 'eat' the rings, also it allows them to 'drink' magic quickly.

; Try to keep from es:di

MM_KeepCell:	mov ah,es:[di]		; Giz the cell
		mov al,ah		; Dup

		and al,0F0h		; Get 'type'
		jz MM_KC_F		; Empty, skip

		cmp al,020h		; Space ?
		je MM_KC_F		; Yes, skip

		; Examine char

		cmp al,cMagic		; Magic potion
		je MM_KC_Magic		; Yes

		cmp al,cTreasure	; Treasure ?
		je MM_KC_Pick		; Yes

		cmp ah,cDead_Sword	; Is it ?
		je MM_KC_Pick		; Yes, pick it up
		cmp ah,cDead_ExMagic	; Is it ?
		je MM_KC_Pick		; Yes, pick it up

		cmp ah,cRings		; Is it a ring/key ?
		jb MM_KC_F		; No, skip

		cmp ah,cKey		; ring/key ?
		ja MM_KC_F		; No, skip

		mov cl,ah		; Giz char
		and cl,07h		; 0 .. 7

		mov al,01h		; Get bit posn.

		shl al,cl		; Shift it

		or b mRingsHeld[si],al	; Set the bit

		mov al,0		; Clear cell

		mov es:[di],al		; Clear it
		call ShowAddr		;

MM_KC_F:	xor al,al		; Nothing
		ret			; Done

; Magic, if it is empty or if man is full pick it up

MM_KC_Magic:	cmp ah,cMagic		; Empty ?
		je MM_KC_Pick		; Yes, try to pick it up

		; It is not empty, is the man full ?

		cmp b mMagic[si],0FFh	; Full ?
		je MM_KC_Pick		; Yes, try to pick it up

		; Drink some

		mov al,es:[di]		; Reduce it
		dec al			;
		mov es:[di],al		;

		call ShowAddr		; on screen

		inc b mMagic[si]	; Step it

		jmp s MM_KC_F		; Done, not taken

; Try to pick it up

MM_KC_Pick:	mov bl,mnSwag[si]	; Amount carried

		cmp bl,16		; Full ?
		je MM_KC_F		; Yes, ignore it

		; Store it

		mov bh,0		; 16-bit

		add bx,mSwag		; Point at data
		add bx,si		;

		mov [bx],ah		; Store the char

		inc b mnSwag[si]	; One more

		; Clear display

MM_KC_Clear:	mov al,0		; Clear the cell
		mov es:[di],al		;
		call ShowAddr		;

		mov al,1		; Flag taken
		ret			; Done

; These are simplified routines, suitable for THINGS

; Try to keep from es:di

Thing_KeepCell:	mov ah,es:[di]		; Giz the cell
		mov al,ah		; Dup

		and al,0F0h		; Get 'type'
		jz T_KC_F		; Empty, skip

		cmp al,020h		; Space ?
		je T_KC_F		; Yes, skip

		; Examine char

		cmp al,cMagic		; Magic potion
		je T_KC_Magic		; Yes

		cmp al,cTreasure	; Treasure ?
		je MM_KC_Pick		; Yes, as man

		; Lets ignore anything else

T_KC_F:		xor al,al		; Nothing
		ret			; Done

; Thing pick up magic

T_KC_Magic:	mov al,ah		; Giz amount
		and al,0Fh		;

		mov ah,mMagic[si]	; Get current
		add ah,al		; Add bottle
		jc T_KC_F		; Can't, full, skip

		; Yes, we can drink it

		mov mMagic[si],al	; Slurp !

		; Remove it from the display

		jmp s MM_KC_Clear	; Yes, clear maze
		
; Try to drop to es:di

MM_DropCell:	test b es:[di],0DFh	; 00 or 20 ?
		jnz MM_KC_F		; No, fail

		; Drop it

		dec b mnSwag[si]	; Dec the number held

		mov bl,mnSwag[si]	; Get number
		mov bh,0		; 16-bit

		add bx,mSwag		; Point at data
		add bx,si		;

		mov al,[bx]		; Giz the swag

		mov es:[di],al		; Write the char
		call ShowAddr		; on screen

		mov al,1		; Assert done
		ret			; Done		

; Given bx as a pointer to a line defn, fire lightning

Thing_F_Light:	push es			; Save es

		; Giz es:bx as a ptr to line defn

		mov ax,cs		; es := cs
		mov es,ax		;

		; These values point away from the man, so we negate them

		neg w cs:sdHoriz[bx]	; Negate the horizontal vector
		neg w cs:sdHoriz+2[bx]	;

		neg w cs:sdDiag[bx]	; And the diagonal vector
		neg w cs:sdDiag+2[bx]	;

		; Now add the lightning

		call Add_Lightning	; Fire one

		; We must point back at the monster (must we ?)
		; or the man's weapons will fire away from the monster (!)

		neg w cs:sdHoriz[bx]	; Negate the horizontal vector
		neg w cs:sdHoriz+2[bx]	;

		neg w cs:sdDiag[bx]	; And the diagonal vector
		neg w cs:sdDiag+2[bx]	;

		; Lightning fired

		pop es			; Restore

		ret			; Done

; Table used to calculate the man's Keep/Drop cell(s)

CL_ManTab:	dw -BM_Y_Stride,0,0	; Up
		dw 0,1,BM_Y_Stride	; Right
		dw 2*BM_Y_Stride,0,0	; Down
		dw 0,-1,BM_Y_Stride	; Left

CL_ThingTab:	dw -BM_Y_Stride,0,0	; Up
		dw 0,1,0		; Right
		dw BM_Y_Stride,0,0	; Down
		dw 0,-1,0		; Left

; This table defines the sword char for a given direction

MM_SwordTab	db cSwords+0		;
		db cSwords+1		;
		db cSwords+1		;
		db cSwords+1		;
		db cSwords+2		;
		db cSwords+3		;
		db cSwords+3		;
		db cSwords+3		;

sMen_Top	db 0A8h,' ',0AAh,' ',0ACh,' ',0AEh,0
sMen_Bottom	db 0A9h,' ',0ABh,' ',0ADh,' ',0AFh,0

TMM_Off		dw ?			; Man position
TMM_Seg		dw ?			;
TMM_Dir		db ?			

Monster_Base	dw ?			; Start paragraph of monsters

