; Wall followers, mostly from JDG, these don't get bored yet.

; LH wall follower

mm_LHW:		push cx			; Save cnt

		; Setup speeds

		mov al,mSpeed[si]	; Reset cnt

		; Can it see the man ??

		mov ah,mFlags[si]	; Get the flags
		and ah,0FDh		; Remove sword

		test w mSightpMan0[si],0FFFFh ; Visible ?
		jz lh_IV		      ; No

		; Yes, the man can see it

		sub al,7		; Faster

		or ah,02h		; Wave sword !

lh_IV:		mov mDelay[si],al	; Write next delay

		mov mFlags[si],ah	; Update sword flag

		; Get its position

		mov di,mSeg[si]		; Point at the maze
		mov es,di		;
		mov di,mOff[si]		;

		mov dl,8		; Number of possible moves

		mov dh,mDirection[si]	; Previous direction
		sub dh,3		; Start towards wall behind

		mov al,dh		; Look to see if on an object
		call can_move		;
		jnz lh_wall1		; Something to cling to

		add dh,2		; Lost in space - try going ahead

lh_wall1:	inc dh			; Step the dirn
		mov al,dh		;

		push es			; Save ptr
		push di			;

		; Look in this dirn.

		call move_move		; Get address

		mov al,es:[di]		; Get cell

		or al,al		; 0 ?
		jz lh_wall2		; Found direction

		; An object is in the way, can we 'eat' it ?

		call Thing_KeepCell	; Try to pick it up

		or al,al		; Did we pick something up ?
		jnz lh_Wall2		; Yes, we can move onto it

		; We didn't 'eat' it, try another direction

		pop di			; Restore posn
		pop es			;

		; Try again

		dec dl			;
		jnz lh_wall1		; Retry

		; No room to move, remain here

		jmp lh_wall3		; Stuck		

		; We have a new posn.

lh_wall2:	pop di			; Restore
		pop es			;

		mov al,0		; Erase old monster
		mov es:[di],al		;

		call ShowAddr		; on screen

		mov al,dh		;
		call move_move		; Find new pointer

		mov al,mChar[si]	;

		mov es:[di],al		; Draw new monster

		call ShowAddr		; on screen

		mov mDirection[si],dh	; Present direction

		mov mOff[si],di		; New location
		mov di,es		;
		mov mSeg[si],di		;

		; Try to fire at the man

lh_wall3:	mov bx,mSightpMan0[si]	; Can we see him ?
		cmp bx,0		;
		jz lhw_X		; No, skip

		; Shall we fire ?

		call Quick_Rand		; Giz a random

		cmp al,Prob_MFL		; Shall we ?
		ja lhw_X		; No, skip

		; Fire a lightning

		call Thing_F_Light	; Fire at the man

		; Done

lhw_X:		pop cx			; Done
		ret			;

; RH wall follower

mm_RHW:		push cx			;

		; Setup speeds

		mov al,mSpeed[si]	; Reset cnt

		; Can it see the man ??

		mov ah,mFlags[si]	; Get the flags
		and ah,0FDh		; Remove sword

		test w mSightpMan0[si],0FFFFh ; Visible ?
		jz rh_IV		      ; No

		; Yes, the man can see it

		sub al,7		; Faster

		or ah,02h		; Wave sword !

rh_IV:		mov mDelay[si],al	; Write next delay

		mov mFlags[si],ah	; Update sword flag

		; Get its position

		mov di,mSeg[si]		; Point at the maze
		mov es,di		;
		mov di,mOff[si]		;

		mov dl,8		; Number of possible moves

		mov dh,mDirection[si]	; Previous direction
		add dh,3		; Start towards wall behind

		mov al,dh		; Look to see if on an object
		call can_move		;
		jnz rh_wall1		; Something to cling to

		sub dh,2		; Lost in space - try going ahead

rh_wall1:	dec dh			; Step the dirn
		mov al,dh		;

		push es			; Save ptr
		push di			;

		; Look in this dirn.

		call move_move		; Get address

		mov al,es:[di]		; Get cell

		or al,al		; 0 ?
		jz rh_wall2		; Found direction

		; An object is in the way, can we 'eat' it ?

		call Thing_KeepCell	; Try to pick it up

		or al,al		; Did we pick something up ?
		jnz rh_Wall2		; Yes, we can move onto it

		; We didn't 'eat' it, try another direction

		pop di			; Restore posn
		pop es			;

		; Try again

		dec dl			;
		jnz rh_wall1		; Retry

		; No room to move, remain here

		jmp rh_wall3		; Stuck		

		; We have a new posn.

rh_wall2:	pop di			; Restore
		pop es			;

		mov al,0		; Erase
		mov es:[di],al		;

		call ShowAddr		;

		mov al,dh		;
		call move_move		; Find new pointer

		mov al,mChar[si]	; Draw the new monster
		mov es:[di],al		;

		call ShowAddr		;

		mov mDirection[si],dh	; Present direction

		mov mOff[si],di		; New location
		mov di,es		;
		mov mSeg[si],di		;

		; Try to fire at the man

rh_wall3:	mov bx,mSightpMan0[si]	; Can we see him ?
		cmp bx,0		;
		jz rhw_X		; No, skip

		; Shall we fire ?

		call Quick_Rand		; Giz a random

		cmp al,Prob_MFL		; Shall we ?
		ja rhw_X		; No, skip

		; Fire a lightning

		call Thing_F_Light	; Fire at the man

		; Done

rhw_X:		pop cx			; Done
		ret			;

; Given a dirn in AL, pos ES:DI return char in that dirn in AL (Z set if clear)

can_move:	push di			; Test if move possible in  dir (AL)
		push es			; Returns char in that direction in AL

		call move_move		; Move pointer
		mov al,es:[di]		; Get character
		or al,al		; Set zero flag

		pop es			;
		pop di			;
		ret			;

; Given AL = dirn, pos ES:DI move to new ES:DI 

move_move:	push ax			;
		push bp			;

		mov bp,es		;

		test al,003h		; Pure up or down
		jz move_move2		;  yes

		test al,004h		; Left or right ?
		jz move_move1		;  ... right

		dec di			;  ... left
		dec di			; Allow to fall through

move_move1:	inc di			;

move_move2:	add al,2		;

		test al,003h		; Pure left or right
		jz move_move4		;  yes

		test al,004h		; Up or down ?
		jnz move_move3		;  ... down

		sub bp,BM_Y_Stride*2	;

move_move3:	add bp,BM_Y_Stride	;

move_move4:	mov es,bp		;

		pop bp			;
		pop ax			;
		ret			;

